(*  The Basic Code Was written by
	Richard Hansen. And "improvements"
	added by Steve Flynn

	I adapted The basic code  for this property editor.  If you don't have it
	You should get the HintEdit property editor written from the above Men!
	This source code may be freely distributed and used. The author
	accepts no responsibility for its use or misuse.
*)

unit TextEdit;

interface

uses
		{$IFDEF WIN32}
			Windows,
		{$ELSE}
			WinTypes, WinProcs,
		{$ENDIF}
		DsgnIntf, SysUtils,Messages, Classes,	Graphics, Controls,
		Forms, Dialogs, StdCtrls, Buttons, Menus, ExtCtrls;

const
	{$IFDEF WIN32}
		 mcMemoLimit = 1024;
	{$ELSE}
		 mcMemoLimit = 255;
	{$ENDIF}
type
	TfrmTextEditor = class(TForm)
			memText  : TMemo;
			RdGp_Justify: TRadioGroup;
    Label1: TLabel;
    SpdBtnCancel: TSpeedButton;
    SpeedButton1: TSpeedButton;
			procedure Activate; override;
			procedure RdGp_JustifyClick(Sender: TObject);
    procedure SpdBtnCancelClick(Sender: TObject);
    procedure SpeedButton1Click(Sender: TObject);
		end;

	TTextProperty = class(TStringProperty)
	public
		procedure Edit; override;
		function GetAttributes: TPropertyAttributes; override;
		end;

procedure ParseText(Lines: TStrings; const S: TCaption);
procedure ExtractText(Lines: TStrings; var S: TCaption);
procedure Register;

implementation

{$R *.DFM}

procedure ParseText(Lines : TStrings; const S : TCaption);
var
	x : Integer;
	Temp : TCaption;

	begin
	if (S <> '') then
		begin
		Temp := '';
		for x := 1 to Length(S) do begin
			if (S[x] = #13) then
				begin
				Lines.Add(Temp);
				Temp := '';
				end
			else
				Temp := Temp + S[x];
			end;
		if (Temp <> '') then
			Lines.Add(Temp);
		end;
	end;

procedure ExtractText(Lines: TStrings; var S: TCaption);
var
	x : Integer;
	begin
	for x := 0 to Lines.Count - 1 do
		begin
		S := S + Lines[x];
		if x < (Lines.Count - 1) then
			S := S + #13;
		end
	end;

procedure TfrmTextEditor.Activate;
begin
	inherited Activate;
		memText.SelectAll;
end;

function TTextProperty.GetAttributes: TPropertyAttributes;
	begin
		Result := [paDialog, paMultiSelect, paAutoUpdate];
	end;

procedure TTextProperty.Edit;
var
	Editor: TfrmTextEditor;
	x: Integer;
	S: TCaption;

	begin
	Editor := TfrmTextEditor.Create(Application);
	Editor.memText.MaxLength := mcMemoLimit;
	try
		S := GetStrValue;
		x := Pos('|', S);
		if (x > 0) then
			ParseText(Editor.memText.Lines, Copy(S, 1, x - 1))
		else
			if (S <> '') then
				ParseText(Editor.memText.Lines, S);
  if (Editor.ShowModal = mrOK) then
			begin
				S := '';
				ExtractText(Editor.memText.Lines, S);
				SetStrValue(S);
			end;
	finally
		Editor.Free;
	end;
end;

procedure Register;
begin
		RegisterPropertyEditor(TypeInfo(TCaption), TComponent, 'TextMsg', TTextProperty);
   RegisterPropertyEditor(TypeInfo(String), TComponent, 'Hint', TTextProperty);
end;

procedure TfrmTextEditor.RdGp_JustifyClick(Sender: TObject);
begin
	 Case RdGp_Justify.ItemIndex Of
		 0 : MemText.Alignment := taLeftJustify;
		 1 : MemText.Alignment := taCenter;
		 2 : MemText.Alignment := taRightJustify
	 end;{case}
end;

procedure TfrmTextEditor.SpdBtnCancelClick(Sender: TObject);
begin
  ModalResult := mrCancel;
end;

procedure TfrmTextEditor.SpeedButton1Click(Sender: TObject);
begin
  ModalResult := mrOk;
end;

end.

